// ACOPY.EXE
// Version 1.02
// ein Kopierprogramm
// kopiert nur Dateien, falls es
//	1.) diese Datei am Zielverzeichnis nicht gibt
//	2.) diese Datei Am Zielverzeichnis lter ist als Quelldatei
//
// Autor: Dipl.Ing. W. Unterberger
// Wien, 8.10.1991
// modifiziert: 9.1.92, 1.3.92
// Zusatz: syswarn(), 17.8.92,

#include <iostream.h>
#include <dir.h>
#include <dos.h>
#include <mem.h>
#include <sys\stat.h>
#include <string.h>
#include <math.h>
#include <process.h>
#include <fstream.h>
#include <fcntl.h>
#include <io.h>
#include <share.h>

#define TRUE	-1
#define FALSE	0
#define SIZE	512
#define FLAGS	FA_RDONLY | FA_HIDDEN | FA_SYSTEM | FA_DIREC | FA_ARCH
#define VERSION 1.02

typedef struct
{ int zeit;
  int datum;
} DATUM;

int SUB;	// Flag fr Unterverzeichnisse


void syserr(char *msg)
{
	cerr << "Fehler aufgetreten:\n\t";
	cerr << msg;
	cerr << "\nProgrammabbruch\n";

	exit(-1);
}

void syswarn(char *msg)
{
	cerr << "Warnung:\t";
	cerr << msg;
}

DATUM getfiledate( int n)
{
	// get date and time from an open file
	union REGS regs;
	DATUM d;
	int ret;

	regs.h.ah = 0x57;
	regs.h.al = 0;	// get
	regs.x.bx = n;	// File handle
	ret = intdos( &regs, &regs);

	d.zeit = regs.x.cx;
	d.datum = regs.x.dx;
	return(d);
}

int setfiledate( DATUM d, int n)
{
	// set date and time of an open file
	union REGS regs;
	int ret;

	regs.h.ah = 0x57;
	regs.h.al = 1;	// set
	regs.x.bx = n;	// File handle
	regs.x.cx = d.zeit;
	regs.x.dx = d.datum;
	ret = intdos( &regs, &regs);

	return(TRUE);
}



void dcopy(char* name1, char* name2)
{
   //ifstream quelle;
   //ofstream ziel;
   unsigned char ch;
   unsigned char buffer[SIZE+10];
   int n = 1, fdin, fdout;
   DATUM dd;
   //struct stat statbuf;

   fdin = sopen( name1, O_RDONLY | O_BINARY, SH_DENYNO);
   if (fdin == -1)
      { syswarn("Fehler beim ffnen einer Quell-Datei!");
	return;
      }

   fdout = sopen( name2, O_WRONLY | O_CREAT | O_TRUNC | O_BINARY, SH_DENYNO, 0777);
   if (fdout == -1)
      { syswarn("Fehler beim ffnen der Ziel-Datei");
	close(fdin);
	return;
      }


   while (n > 0)
   {
     n = read( fdin, buffer, SIZE);
     if ( n == 0) break;

     if ( n == -1 )
     {  cerr << "Fehler bei Lesen von " << name1 << "!\n";
	close(fdin); close(fdout);
	return;
     }
     n = write( fdout, buffer, n);
   }

   dd = getfiledate( fdin);
   setfiledate( dd, fdout);


   close( fdin); close( fdout);
   cout << name1 << endl;

}


void acopy(char* qustr, char* fname, char* zistr)
{
    int sch1, sch2;
    char strg1[130], strg2[130];
    struct ffblk fblk1, fblk2;
    struct stat st1, st2;
    int i, j, m, punkt;


// existiert Zielverzeichnis??
    j = findfirst( zistr, &fblk2, FA_DIREC);
    if (j < 0)
    {  m = mkdir(zistr);
       if (m < 0) syserr("Zielverzeichnis kann nicht geffnet werden!");
    }


    strcpy( strg1, qustr);
    if ( fname[0] != '\0')	// Filename wurd mitgegeben!
    {  strcat( strg1, "\\");
       strcat( strg1, fname);
    }

    i = findfirst(strg1, &fblk1, FLAGS);

//cout << "acopy: Quellname = " << strg1 << " Res: " << i << "\n";
//cout << "Zielname = " << zistr << "\n\n";

    do
    {
       if (i == 0)		// etwas gefunden
       {
	 strcpy( strg1, qustr);
	 strcpy( strg2, zistr);
	 strcat( strg1, "\\");
	 strcat( strg2, "\\");
	 strcat( strg2, fblk1.ff_name);
	 strcat( strg1, fblk1.ff_name);

	 stat( strg1, &st1);	// Info darber
	 if (st1.st_mode & S_IFDIR) sch1 = TRUE;
	 else sch1 = FALSE;

	 if ((strcmp(fblk1.ff_name, ".") == 0) || (strcmp(fblk1.ff_name, "..")
	       == 0))
	    punkt = 1;
	 else punkt = 0;


	 if ( sch1 )		// Verzeichnis!
	 {
	   if ((punkt == 0) && (SUB == 1))
	   {
	     // gibt es Zielverzeichnis?

	     j = findfirst( strg2, &fblk2, FA_DIREC);
	     if (j == 0)			// Zielverzeichnis vorhanden
		acopy( strg1, "*.*", strg2);

	     else
	     {  m = mkdir(strg2);
		if (m < 0) syserr("Verzeichnis kann nicht geffnet werden!");
		acopy( strg1, "*.*", strg2);
	     }
	   }				// Ende punkt == 0
	 }				// Ende Verzeichnis


	else		// also kein Directory
			// es werden Dateien kopiert
	{

	   j = findfirst( strg2, &fblk2, FLAGS);

	   if (j == 0)
	      {
		// gefunden
		// Abfrage auf Datum
		stat( strg2, &st2);	// Info darber
//		if (st2.st_mode & S_IFDIR) sch2 = TRUE;
//		else sch2 = FALSE;

	      if (st2.st_atime  < st1.st_atime)
		 dcopy( strg1, strg2);

	      }
	   else 		// Datei nicht gefunden
		dcopy( strg1, strg2);

	}

	  i = findnext( &fblk1);

       }		// Ende i == 0
			// nichts gefunden!
			// hierher gehrt noch:
			// Suche in Unterverzeichnissen!!
       else break;	// Ende der Schleife!
    } while (TRUE);


}		// Ende acopy ()



main( int argc, char *argv[])
{
	int i, n;
	struct ffblk fk1;
	struct stat ss1;
	char s1[130], s2[130], hbuff[130];
	char *sptr;

    if ((argc < 3) || (argc > 4))
       { cerr << "\nACOPY Version " << VERSION << endl;
	 cerr << "Aufruf: ACOPY  Quellverzeichnis Zielverzeichnis [/s]\n\n";
	 cerr << "\tACOPY kopiert alle Dateien vom Quellverzeichnis ins\n";
	 cerr << "\tZielverzeichnis, falls sie im Zielverzeichnis:\n";
	 cerr << "\t1.) lter sind als im Quellverzeichnis\n";
	 cerr << "\t2.) nicht existieren\n";
	 cerr << "\tmit /s werden auch die Unterverzeichnisse bercksichtigt\n";

	 exit(-1);
       }

    SUB = 0;
    s1[0] = s2[0] = '\0';

    for (i=1; i<argc; i++)
	if ((strcmp(argv[i], "/s") == 0) || (strcmp(argv[i], "/S") == 0))
	   SUB = 1;
	else if ( s1[0] != '\0') strcpy( s2, argv[i]);
	     else strcpy( s1, argv[i]);


    i = findfirst( s1, &fk1, FLAGS);	// existiert?
    if (i != 0)
       syserr("Quellverzeichnis existiert nicht!");

    cout << "\n";	// zur besseren Lesbarkeit

    // File oder Directory?
    sptr = strpbrk( s1, "*?");
    if (sptr)		// Wildcards im Quellnamen!!
    {  sptr = strrchr( s1, '\\');	// Trenne Directory
       if (!sptr) { acopy( ".\\", s1, s2); exit(0); }
       memset( hbuff, '\0', 130);	//von File
       n = abs(s1 - sptr);
       strncpy(hbuff, s1, n);		// hbuff enthlt Directory
       hbuff[n] = '\0';
       acopy( hbuff, sptr+1, s2);
    }
    else
       { stat( s1, &ss1);
	 if ( (ss1.st_mode & S_IFDIR) == S_IFDIR)
	    acopy( s1, "*.*", s2);
	 else
	    acopy( s1, "", s2);
       }

}
