/********************** rmd.c
 removes directories (-trees), even when they are full!

 Walter Unterberger 19/07/89, 17/08/92

 This got compiled with Borland C++ Version 3.0
 *****************************/
 #include <stdio.h>
 #include <dir.h>
 #include <dos.h>

 static char * finame;

void syserr(msg)	/* Display error and exit */
   char * msg;

{
   extern int errno, sys_nerr;
   extern char * sys_errlist[];

   fprintf(stderr, "ERROR: %s (%d", msg, errno);
   if (errno > 0 && errno < sys_nerr)
      fprintf(stderr, "; %s)\n", sys_errlist[errno]);
   else
      fprintf(stderr, ")\n");
   exit(1);
}

void fatal(msg)		/* Display error and exit */
   char * msg;

{
   fprintf(stderr, "ERROR: %s\n", msg);
   exit(1);
}


 void remfile()		/* remove File	*/
 {
  int n;
  struct ffblk filedata;
  char fnam[14], tmp[100];

	n = findfirst("*.*", &filedata, 0x7F);	/* find them all */
	while (n == 0)
	{ if (filedata.ff_attrib == FA_RDONLY)
	     { strcpy(tmp, "File is readonly - ");
	       strcat(tmp, filedata.ff_name);
	       fatal(tmp);
	     }

	  strcpy(fnam, filedata.ff_name);
	  printf("  %s\n", fnam);

	  if (filedata.ff_attrib != FA_DIREC)
	     {
	       remove(fnam);		/* delete file */
	     }
	  else
	     { if (fnam[0] == '.')
		  { n = findnext(&filedata);
		    continue;
		  }
	       if (chdir(fnam) != 0)
		   syserr("chdir");
	       remfile();
	       chdir("..");
	       if (rmdir(fnam) == -1)
		  syserr("rmdir");
	     }

	  n = findnext(&filedata);
	}
 }


 main(argc,argv)
 int argc;
 char *argv[];
 {
  char curdir[128], newdir[128];
  int curdrv, newdrv;
  char *drvptr;

  if (argc < 2)
     { printf("\nUsage: rmd directory_name\n");
       exit(1);
     }
  /* Filename is ... */
  finame = argv[1];
  if ((strcmp(finame,".") == 0) || (strcmp(finame,"..") == 0))
     { printf("\nError in directory name\n");
       exit(1);
     }

  /* get current directory, including drive */
  (void)getcwd( curdir, 128);
  curdrv = getdisk();	/* not on Unix - sorry */


  /* now set active drive, if necessary ... */
  drvptr =(char near *) strchr(finame, ':');
  if (drvptr)	/* a drive was selected	*/
  {
     newdrv = toupper(finame[0]);	/* this must be the drive letter */
     if ((newdrv <= 'Z') && (newdrv >= 'A'))
	setdisk( newdrv - 'A');
  }

  if (chdir(finame) != 0)
     syserr("chdir");

  remfile();		/* this is the true remove function */

  if (chdir("..") != 0) /* back to the start directory */
     syserr("chdir ");
  if (rmdir(finame) == -1)
      syserr("rmdir");

  setdisk(curdrv);
  chdir(curdir);
  return(0);		/* for my compiler only ... */
}
