/********************** walk.c
 walks thru directories (-trees) and executes batchfile

 Walter Unterberger 03/01/93

 This got compiled with Borland Turbo C Version 2.0
 *****************************/
#include <stdio.h>
#include <dir.h>
#include <dos.h>
#include <string.h>

extern unsigned _stklen = 58000U;

static char batchfile[255];
static char pfad[255];

void execbatch(void);


void syserr(char *msg)	/* Display error and exit */
{
   extern int errno, sys_nerr;
   extern char * sys_errlist[];

   fprintf(stderr, "ERROR: %s (%d", msg, errno);
   if (errno > 0 && errno < sys_nerr)
      fprintf(stderr, "; %s)\n", sys_errlist[errno]);
   else
      fprintf(stderr, ")\n");
   exit(1);
}

void fatal(char *msg)		/* Display error and exit */
{
   fprintf(stderr, "ERROR: %s\n", msg);
   exit(1);
}


void execbatch()		/* walk thru the directories	*/
 {
  int n;
  struct ffblk filedata;
  char fnam[14];


	system( batchfile);	/* execute batchfile */
				/* now walk thru subdirectories */

	n = findfirst("*.*", &filedata, FA_DIREC);	/* find all dir's */
	while (n == 0)
	{
	  strcpy(fnam, filedata.ff_name);
	  /*fprintf(stdout, "  %s\n", fnam);*/

	  if (filedata.ff_attrib == FA_DIREC)
	     { if (fnam[0] == '.')
		{ n = findnext(&filedata);
		    continue;
		}
	       if (chdir(fnam) != 0)
		   syserr("chdir");
	       execbatch();
	       chdir("..");
	     }

	  n = findnext(&filedata);
	}
 }


int main(int argc, char *argv[])
{
  static char curdir[255];
  static int curdrv, newdrv;
  static char *drvptr;


  if (argc < 3)
     { printf("\nUsage: walk directory_name batchfile\n");
       exit(1);
     }

  /* directory is ... */
  strcpy( pfad, argv[1]);

  strcpy(batchfile, argv[2]);
  drvptr = strstr( batchfile, "BAT");
  if (drvptr == NULL) drvptr=strstr( batchfile, "bat");

  if ( drvptr == NULL)
     { printf("\n.BAT is missing!\n");
       exit(1);
     }
  /* Let's hope the batchfile exists */

  /* get current directory, including drive */
  (void)getcwd( curdir, 128);
  curdrv = getdisk();	/* not on Unix - sorry */


  /* now set active drive, if necessary ... */
  drvptr = strchr(pfad, ':');
  if (drvptr && (drvptr < pfad+2))	/* a drive was selected	*/
  {
     newdrv = toupper(pfad[0]);		/* this must be the drive letter */
     if ((newdrv <= 'Z') && (newdrv >= 'A'))
	setdisk( newdrv - 'A');
  }

  if (chdir(pfad) != 0)
     { printf("\nError in directory name\n");
       exit(1);
     }

  execbatch();		/* this is the true walk function */

  setdisk(curdrv);
  chdir(curdir);
  return(0);		/* for my compiler only ... */
}
